diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawner.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawner.java
index b586c93e1..105332d41 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawner.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicMobSpawner.java
@@ -33,7 +33,7 @@ public class BlockLogicMobSpawner extends BlockLogicMobSpawnerDeactivated
 
     @Override
 	public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
-    	TileEntityMobSpawner tileEntity = (TileEntityMobSpawner) world.getBlockEntity(x, y, z);
+    	TileEntityMobSpawner tileEntity = (TileEntityMobSpawner) world.getTileEntity(x, y, z);
     	tileEntity.setMobId("none");
     }
 
@@ -41,7 +41,7 @@ public class BlockLogicMobSpawner extends BlockLogicMobSpawnerDeactivated
     public void onBlockRemoved(World world, int x, int y, int z, int data)
     {
         if (!world.isClientSide) {
-            TileEntityMobSpawner tileEntityMobSpawner = (TileEntityMobSpawner) world.getBlockEntity(x, y, z);
+            TileEntityMobSpawner tileEntityMobSpawner = (TileEntityMobSpawner) world.getTileEntity(x, y, z);
             if (tileEntityMobSpawner == null) return;
             int amountToDrop = world.rand.nextInt(10) + 10;
             label0:
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRailDetector.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRailDetector.java
index df2c001f8..e912ac8c7 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRailDetector.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRailDetector.java
@@ -4,7 +4,7 @@ import java.util.List;
 import java.util.Random;
 
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.vehicle.MinecartEntity;
+import net.minecraft.core.entity.vehicle.EntityMinecart;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
@@ -67,7 +67,7 @@ public class BlockLogicRailDetector extends BlockLogicRail {
         boolean isPowered = (meta & MASK_POWERED) != 0;
         boolean minecartPresent = false;
         float offset = 0.125f;
-        List<MinecartEntity> list = world.getEntitiesWithinAABB(MinecartEntity.class, AABB.getTemporaryBB(x + offset, y + offset, z + offset, x + 1 - offset, y + 1 - offset, z + 1 - offset));
+        List<EntityMinecart> list = world.getEntitiesWithinAABB(EntityMinecart.class, AABB.getTemporaryBB(x + offset, y + offset, z + offset, x + 1 - offset, y + 1 - offset, z + 1 - offset));
         if(!list.isEmpty()) {
             minecartPresent = true;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSeat.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSeat.java
index 7a46e4ab6..b971b8d49 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSeat.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSeat.java
@@ -24,7 +24,7 @@ public class BlockLogicSeat extends BlockLogic
             return false;
         }
         if (!world.isClientSide) {
-            TileEntitySeat tileEntity = (TileEntitySeat) world.getBlockEntity(x, y, z);
+            TileEntitySeat tileEntity = (TileEntitySeat) world.getTileEntity(x, y, z);
             if (tileEntity.getPassenger() == null) {
                 player.startRiding(tileEntity);
             }
@@ -36,7 +36,7 @@ public class BlockLogicSeat extends BlockLogic
     @Override
     public void onBlockRemoved(World world, int x, int y, int z, int data) {
         if (!world.isClientSide) {
-            TileEntitySeat tileEntity = (TileEntitySeat) world.getBlockEntity(x, y, z);
+            TileEntitySeat tileEntity = (TileEntitySeat) world.getTileEntity(x, y, z);
             if (tileEntity != null && tileEntity.getPassenger() != null) {
                 tileEntity.ejectRider();
             }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
index 11124b42c..25b5d10d0 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
@@ -15,7 +15,11 @@ import net.minecraft.core.world.WorldSource;
 
 public class BlockLogicSign extends BlockLogic
 {
-    private final boolean isFreeStanding;
+    public static final int SIDE_NORTH = 2;
+    public static final int SIDE_SOUTH = 3;
+    public static final int SIDE_WEST = 4;
+    public static final int SIDE_EAST = 5;
+    public final boolean isFreeStanding;
 
 	public BlockLogicSign(Block<?> block, boolean isFreeStanding)
     {
@@ -36,48 +40,22 @@ public class BlockLogicSign extends BlockLogic
     @Override
     public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
     {
-        if(isFreeStanding)
-        {
+        if(isFreeStanding) {
             return getBounds();
         }
-        int l = world.getBlockMetadata(x, y, z);
-        float f = 0.28125F;
-        float f1 = 0.78125F;
-        float f2 = 0.0F;
-        float f3 = 1.0F;
-        float f4 = 0.125F;
-                /*int l = world.getBlockMetadata(i, j, k);
-        float f = 0.28125F;
-        float f1 = 0.78125F;
-        float f2 = 0.0F;
-        float f3 = 1.0F;
-        float f4 = -0.275F;
-        setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
-        if(l == 2)
-        {
-            setBlockBounds(f2, f, 1.5F - f4, f3, f1, 1.275F);
-        }
-        if(l == 3)
-        {
-            setBlockBounds(f2, f, -0.375F, f3, f1, f4);
-        }
-        if(l == 4)
-        {
-            setBlockBounds(1.5F - f4, f, f2, 1.275F, f1, f3);
-        }
-        if(l == 5)
-        {
-            setBlockBounds(-0.375F, f, f2, f4, f1, f3);
-        }*/
-        switch (l) {
-            case 2:
-                return AABB.getTemporaryBB(f2, f, 1.0F - f4, f3, f1, 1.0F);
-            case 3:
-                return AABB.getTemporaryBB(f2, f, 0.0F, f3, f1, f4);
-            case 4:
-                return AABB.getTemporaryBB(1.0F - f4, f, f2, 1.0F, f1, f3);
-            case 5:
-                return AABB.getTemporaryBB(0.0F, f, f2, f4, f1, f3);
+        float bottom = 4.5f / 16f;
+        float top = 12.5f / 16f;
+        float width = 16f / 16f;
+        float thickness = 2.0f / 16f;
+        switch (world.getBlockMetadata(x, y, z)) {
+            case SIDE_NORTH:
+                return AABB.getTemporaryBB(0.0F, bottom, 1.0F - thickness, width, top, 1.0F);
+            case SIDE_SOUTH:
+                return AABB.getTemporaryBB(0.0F, bottom, 0.0F, width, top, thickness);
+            case SIDE_WEST:
+                return AABB.getTemporaryBB(1.0F - thickness, bottom, 0.0F, 1.0F, top, width);
+            case SIDE_EAST:
+                return AABB.getTemporaryBB(0.0F, bottom, 0.0F, thickness, top, width);
             default:
                 return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
         }
@@ -98,35 +76,33 @@ public class BlockLogicSign extends BlockLogic
     @Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
     {
-        boolean flag = false;
+        boolean isUnstable = false;
         if(isFreeStanding)
         {
             if(!world.getBlockMaterial(x, y - 1, z).isSolid())
             {
-                flag = true;
+                isUnstable = true;
             }
         } else
         {
-            int i1 = world.getBlockMetadata(x, y, z);
-            flag = true;
-            if(i1 == 2 && world.getBlockMaterial(x, y, z + 1).isSolid())
-            {
-                flag = false;
-            }
-            if(i1 == 3 && world.getBlockMaterial(x, y, z - 1).isSolid())
-            {
-                flag = false;
-            }
-            if(i1 == 4 && world.getBlockMaterial(x + 1, y, z).isSolid())
-            {
-                flag = false;
-            }
-            if(i1 == 5 && world.getBlockMaterial(x - 1, y, z).isSolid())
-            {
-                flag = false;
+            switch (world.getBlockMetadata(x, y, z)) {
+                case SIDE_NORTH:
+                    isUnstable = !world.getBlockMaterial(x, y, z + 1).isSolid();
+                    break;
+                case SIDE_SOUTH:
+                    isUnstable = !world.getBlockMaterial(x, y, z - 1).isSolid();
+                    break;
+                case SIDE_WEST:
+                    isUnstable = !world.getBlockMaterial(x + 1, y, z).isSolid();
+                    break;
+                case SIDE_EAST:
+                    isUnstable = !world.getBlockMaterial(x - 1, y, z).isSolid();
+                    break;
+                default:
+                    isUnstable = true;
             }
         }
-        if(flag)
+        if(isUnstable)
         {
             dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
             world.setBlockWithNotify(x, y, z, 0);
@@ -140,7 +116,7 @@ public class BlockLogicSign extends BlockLogic
     }
     @Override
     public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced) {
-        TileEntitySign signEntity = (TileEntitySign)world.getBlockEntity(x, y, z);
+        TileEntitySign signEntity = (TileEntitySign)world.getTileEntity(x, y, z);
         if (signEntity != null && player != null) {
             if (player.getHeldItem() != null && player.getHeldItem().itemID == Items.DUST_GLOWSTONE.id && !signEntity.isGlowing()) {
                 signEntity.setGlowing(true);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java
index 12f9b7a20..871d61085 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java
@@ -42,73 +42,101 @@ public class BlockLogicStatue extends BlockLogic {
 
     @Override
     public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit) {
-        final @NotNull HumanArmorShape armorShape;
+        final @Nullable TileEntityStatue statueEntity = getTileEntity(world, x, y, z);
+        if (statueEntity == null) {
+            return false;
+        }
+
+        // Sneaking overrides all - next pose
+        if (player.isSneaking()) {
+            statueEntity.nextPose();
+            return true;
+        }
+
+        final @Nullable HumanArmorShape interactSlot;
         if (side == Side.TOP || yHit >= 0.5f) {
             if (this.isBottom) {
-                armorShape = HumanArmorShape.LEGS;
+                interactSlot = HumanArmorShape.LEGS;
             } else {
-                armorShape = HumanArmorShape.HEAD;
+                interactSlot = HumanArmorShape.HEAD;
             }
         } else if (side == Side.BOTTOM || yHit < 0.5f) {
             if (this.isBottom) {
-                armorShape = HumanArmorShape.BOOTS;
+                interactSlot = HumanArmorShape.BOOTS;
             } else {
-                armorShape = HumanArmorShape.CHEST;
+                interactSlot = HumanArmorShape.CHEST;
             }
         } else {
-            return false;
-        }
-
-        final @Nullable TileEntityStatue statueEntity = getTileEntity(world, x, y, z);
-        if (statueEntity == null) {
-            return false;
-        }
-        final @Nullable ItemStack storedItemStack = statueEntity.getItemInArmorSlot(armorShape);
-
-        boolean takeItem = false;
-        if (storedItemStack != null && storedItemStack.getItem() != null) {
-            takeItem = true;
+            interactSlot = null;
         }
 
-        boolean storeItem = false;
-        final @Nullable ItemStack heldItemStack = player.getHeldItem();
-        if (heldItemStack != null) {
-            final @Nullable Item heldItem = heldItemStack.getItem();
-            if (heldItem != null) {
-                if (heldItem instanceof IArmorItem<?> && ((IArmorItem<?>) heldItem).getArmorShape() == armorShape) {
-                    storeItem = true;
-                }
+        final @Nullable ItemStack statueHeldItemStack = statueEntity.getHeldItem();
+        final @Nullable Item statueHeldItem = statueHeldItemStack != null ? statueHeldItemStack.getItem() : null;
+        final @Nullable ItemStack statueArmorItemStack = interactSlot != null ? statueEntity.getItemInArmorSlot(interactSlot) : null;
+        final @Nullable Item statueArmorItem = statueArmorItemStack != null ? statueArmorItemStack.getItem() : null;
+        final @Nullable ItemStack playerHeldItemStack = player.getHeldItem();
+        final @Nullable Item playerHeldItem = playerHeldItemStack != null ? playerHeldItemStack.getItem() : null;
+
+        final boolean isPlayerHoldingArmor = playerHeldItem instanceof IArmorItem && ((IArmorItem<?>) playerHeldItem).getArmorShape() == interactSlot;
+        final boolean isPlayerHandEmpty = playerHeldItem == null;
+        final boolean isStatueHandEmpty = statueHeldItem == null;
+        final boolean isStatueArmorEmpty = statueArmorItem == null;
+
+        final boolean shouldTakeItem = !isStatueHandEmpty && !isPlayerHoldingArmor;
+        final boolean shouldInsertItem = !isPlayerHandEmpty && !isPlayerHoldingArmor;
+        final boolean shouldTakeArmor = interactSlot != null && !isStatueArmorEmpty && isStatueHandEmpty;
+        final boolean shouldInsertArmor = interactSlot != null && isPlayerHoldingArmor;
+
+        // Handle item interaction
+        if (shouldTakeItem && shouldInsertItem) {
+            if (playerHeldItemStack.consumeItem(player)) {
+                final @NotNull ItemStack newStack = playerHeldItemStack.copy();
+                newStack.stackSize = 1;
+                player.inventory.insertItem(statueHeldItemStack, true);
+                statueEntity.setHeldItem(newStack);
+                return true;
+            } else {
+                return false;
+            }
+        } else if (shouldTakeItem) {
+            player.inventory.insertItem(statueHeldItemStack, true);
+            statueEntity.setHeldItem(null);
+            return true;
+        } else if (shouldInsertItem) {
+            if (playerHeldItemStack.consumeItem(player)) {
+                final @NotNull ItemStack newStack = playerHeldItemStack.copy();
+                newStack.stackSize = 1;
+                statueEntity.setHeldItem(newStack);
+                return true;
+            } else {
+                return false;
             }
         }
 
-        if (takeItem && storeItem) {
-            if (heldItemStack.consumeItem(player)) {
-                final @NotNull ItemStack newStack = heldItemStack.copy();
+        // Handle armor interaction
+        if (shouldTakeArmor && shouldInsertArmor) {
+            if (playerHeldItemStack.consumeItem(player)) {
+                final @NotNull ItemStack newStack = playerHeldItemStack.copy();
                 newStack.stackSize = 1;
-                player.inventory.insertItem(storedItemStack, true);
-                statueEntity.setItemInArmorSlot(armorShape, newStack);
+                player.inventory.insertItem(statueArmorItemStack, true);
+                statueEntity.setItemInArmorSlot(interactSlot, newStack);
                 return true;
             } else {
                 return false;
             }
-        } else if (takeItem) {
-            player.inventory.insertItem(storedItemStack, true);
-            statueEntity.setItemInArmorSlot(armorShape, null);
+        } else if (shouldTakeArmor) {
+            player.inventory.insertItem(statueArmorItemStack, true);
+            statueEntity.setItemInArmorSlot(interactSlot, null);
             return true;
-        } else if (storeItem) {
-            if (heldItemStack.consumeItem(player)) {
-                final @NotNull ItemStack newStack = heldItemStack.copy();
+        } else if (shouldInsertArmor) {
+            if (playerHeldItemStack.consumeItem(player)) {
+                final @NotNull ItemStack newStack = playerHeldItemStack.copy();
                 newStack.stackSize = 1;
-                statueEntity.setItemInArmorSlot(armorShape, newStack);
+                statueEntity.setItemInArmorSlot(interactSlot, newStack);
                 return true;
             } else {
                 return false;
             }
-        } else {
-            if (heldItemStack == null || heldItemStack.getItem() == null) {
-                statueEntity.nextPose();
-                return true;
-            }
         }
 
         return false;
@@ -130,7 +158,7 @@ public class BlockLogicStatue extends BlockLogic {
             return null;
         }
 
-        final @Nullable TileEntity tileEntity = world.getBlockEntity(x, this.isBottom ? y : y - 1, z);
+        final @Nullable TileEntity tileEntity = world.getTileEntity(x, this.isBottom ? y : y - 1, z);
         if (!(tileEntity instanceof TileEntityStatue)) {
             return null;
         }
@@ -142,7 +170,7 @@ public class BlockLogicStatue extends BlockLogic {
     public void onBlockRemoved(World world, int x, int y, int z, int data) {
         if (this.isBottom) {
             List<ItemStack> stacks = new ArrayList<>();
-            final @Nullable TileEntity tileEntity = world.getBlockEntity(x, y, z);
+            final @Nullable TileEntity tileEntity = world.getTileEntity(x, y, z);
             if (tileEntity != null) {
                 TileEntityStatue statueEntity = (TileEntityStatue) tileEntity;
                 for (HumanArmorShape armorShape : HumanArmorShape.values()) {
@@ -151,6 +179,10 @@ public class BlockLogicStatue extends BlockLogic {
                         stacks.add(armorStack);
                     }
                 }
+                @Nullable ItemStack heldItemStack = statueEntity.getHeldItem();
+                if (heldItemStack != null) {
+                    stacks.add(heldItemStack);
+                }
             }
 
             for (ItemStack stack : stacks) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java
index 58b7e4e4f..f8b623f48 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrapDoor.java
@@ -144,7 +144,7 @@ public class BlockLogicTrapDoor extends BlockLogic implements IPaintable {
             BlockLogicLadder ladder = (BlockLogicLadder) block.getLogic();
             Side ladderSide = ladder.getSideFromMeta(world.getBlockMetadata(x, y - 1, z));
             Direction trapdoorDirection = getDirectionForMeta(meta);
-            return ladderSide.getDirection().getOpposite() == trapdoorDirection;
+            return ladderSide.getDirection() == trapdoorDirection.getOpposite();
         }
         return false;
     }
@@ -190,7 +190,17 @@ public class BlockLogicTrapDoor extends BlockLogic implements IPaintable {
     }
 
     public Direction getDirectionForMeta(int meta) {
-        return Direction.getDirectionById(meta & MASK_DIRECTION);
+        switch (meta & MASK_DIRECTION) {
+            case DIRECTION_SOUTH:
+                return Direction.SOUTH;
+            case DIRECTION_NORTH:
+                return Direction.NORTH;
+            case DIRECTION_EAST:
+                return Direction.EAST;
+            case DIRECTION_WEST:
+                return Direction.WEST;
+        }
+        return Direction.NONE;
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrommel.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrommel.java
index facc7586c..bcb02c841 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrommel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicTrommel.java
@@ -43,7 +43,7 @@ public class BlockLogicTrommel extends BlockLogicRotatable
     public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
         if (!world.isClientSide) {
-            TileEntityTrommel tileEntityTrommel = (TileEntityTrommel) world.getBlockEntity(x, y, z);
+            TileEntityTrommel tileEntityTrommel = (TileEntityTrommel) world.getTileEntity(x, y, z);
             player.displayTrommelScreen(tileEntityTrommel);
         }
         return true;
@@ -63,7 +63,7 @@ public class BlockLogicTrommel extends BlockLogicRotatable
     public static void updateTrommelBlockState(boolean lit, World world, int x, int y, int z)
     {
         int l = world.getBlockMetadata(x, y, z);
-        TileEntity tileEntity = world.getBlockEntity(x, y, z);
+        TileEntity tileEntity = world.getTileEntity(x, y, z);
         if(tileEntity == null) {
             String msg = "Trommel is missing Tile Entity at x: " + x + " y: " + y + " z: " + z + ", block will be removed!";
             if(Global.BUILD_CHANNEL.isUnstableBuild()) {
@@ -84,7 +84,7 @@ public class BlockLogicTrommel extends BlockLogicRotatable
         keepTrommelInventory = false;
         world.setBlockMetadataWithNotify(x, y, z, l);
         tileEntity.validate();
-        world.setBlockTileEntity(x, y, z, tileEntity);
+        world.setTileEntity(x, y, z, tileEntity);
     }
 
     private boolean isActive;
diff --git a/game/core/src/main/java/net/minecraft/core/block/Blocks.java b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
index 0e8aedef7..31cb0d1ab 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
@@ -983,10 +983,10 @@ public final class Blocks {
         .withSound(BlockSounds.GRAVEL).withHardness(0.6F).withLitInteriorSurface(true).withDisabledNeighborNotifyOnMetadataChange()
         .withTags(BlockTags.MINEABLE_BY_SHOVEL);
 
-    public static final Block<?> SIGN_POST_PLANKS_OAK = register("sign.post.planks.oak", "minecraft:block/sign_post_planks_oak", 710, (b) -> new BlockLogicSign(b, true))
+    public static final Block<BlockLogicSign> SIGN_POST_PLANKS_OAK = register("sign.post.planks.oak", "minecraft:block/sign_post_planks_oak", 710, (BlockLogicSupplier<BlockLogicSign>)(b) -> new BlockLogicSign(b, true))
         .withSound(BlockSounds.WOOD).withHardness(1.0F).withDisabledNeighborNotifyOnMetadataChange().setStatParent(() -> Items.SIGN)
         .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_AXE);
-    public static final Block<?> SIGN_WALL_PLANKS_OAK = register("sign.wall.planks.oak", "minecraft:block/sign_wall_planks_oak", 711, (b) -> new BlockLogicSign(b, false))
+    public static final Block<BlockLogicSign> SIGN_WALL_PLANKS_OAK = register("sign.wall.planks.oak", "minecraft:block/sign_wall_planks_oak", 711, (BlockLogicSupplier<BlockLogicSign>)(b) -> new BlockLogicSign(b, false))
         .withSound(BlockSounds.WOOD).withHardness(1.0F).withDisabledNeighborNotifyOnMetadataChange().setStatParent(() -> SIGN_POST_PLANKS_OAK)
         .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_AXE);
 
@@ -1205,12 +1205,43 @@ public final class Blocks {
         .withSound(BlockSounds.PERMAFROST).withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE);
 
-    public static final Block<BlockLogicStatue> STATUE_STONE_LOWER = register("statue.stone.lower", "minecraft:block/statue_lower", 1010, (BlockLogicSupplier<BlockLogicStatue>) b -> new BlockLogicStatue(b, Material.stone, true, () -> Items.STATUE_STONE))
+    public static final Block<BlockLogicStatue> STATUE_STONE_LOWER = register("statue.stone.lower", "minecraft:block/statue_stone_lower", 1010, (BlockLogicSupplier<BlockLogicStatue>) b -> new BlockLogicStatue(b, Material.stone, true, () -> Items.STATUE_STONE))
         .withSound(BlockSounds.STONE).withHardness(1.5F)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NOT_IN_CREATIVE_MENU);
-    public static final Block<BlockLogicStatue> STATUE_STONE_UPPER = register("statue.stone.upper", "minecraft:block/statue_upper", 1011, (BlockLogicSupplier<BlockLogicStatue>) b -> new BlockLogicStatue(b, Material.stone, false, () -> Items.STATUE_STONE))
+    public static final Block<BlockLogicStatue> STATUE_STONE_UPPER = register("statue.stone.upper", "minecraft:block/statue_stone_upper", 1011, (BlockLogicSupplier<BlockLogicStatue>) b -> new BlockLogicStatue(b, Material.stone, false, () -> Items.STATUE_STONE))
         .withSound(BlockSounds.STONE).withHardness(1.5F)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NOT_IN_CREATIVE_MENU);
+    public static final Block<BlockLogicStatue> STATUE_BASALT_LOWER = register("statue.basalt.lower", "minecraft:block/statue_basalt_lower", 1012, (BlockLogicSupplier<BlockLogicStatue>) b -> new BlockLogicStatue(b, Material.stone, true, () -> Items.STATUE_BASALT))
+        .withSound(BlockSounds.STONE).withHardness(1.5F)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NOT_IN_CREATIVE_MENU);
+    public static final Block<BlockLogicStatue> STATUE_BASALT_UPPER = register("statue.basalt.upper", "minecraft:block/statue_basalt_upper", 1013, (BlockLogicSupplier<BlockLogicStatue>) b -> new BlockLogicStatue(b, Material.stone, false, () -> Items.STATUE_BASALT))
+        .withSound(BlockSounds.STONE).withHardness(1.5F)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NOT_IN_CREATIVE_MENU);
+    public static final Block<BlockLogicStatue> STATUE_LIMESTONE_LOWER = register("statue.limestone.lower", "minecraft:block/statue_limestone_lower", 1014, (BlockLogicSupplier<BlockLogicStatue>) b -> new BlockLogicStatue(b, Material.stone, true, () -> Items.STATUE_LIMESTONE))
+        .withSound(BlockSounds.STONE).withHardness(1.5F)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NOT_IN_CREATIVE_MENU);
+    public static final Block<BlockLogicStatue> STATUE_LIMESTONE_UPPER = register("statue.limestone.upper", "minecraft:block/statue_limestone_upper", 1015, (BlockLogicSupplier<BlockLogicStatue>) b -> new BlockLogicStatue(b, Material.stone, false, () -> Items.STATUE_LIMESTONE))
+        .withSound(BlockSounds.STONE).withHardness(1.5F)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NOT_IN_CREATIVE_MENU);
+    public static final Block<BlockLogicStatue> STATUE_GRANITE_LOWER = register("statue.granite.lower", "minecraft:block/statue_granite_lower", 1016, (BlockLogicSupplier<BlockLogicStatue>) b -> new BlockLogicStatue(b, Material.stone, true, () -> Items.STATUE_GRANITE))
+        .withSound(BlockSounds.STONE).withHardness(1.5F)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NOT_IN_CREATIVE_MENU);
+    public static final Block<BlockLogicStatue> STATUE_GRANITE_UPPER = register("statue.granite.upper", "minecraft:block/statue_granite_upper", 1017, (BlockLogicSupplier<BlockLogicStatue>) b -> new BlockLogicStatue(b, Material.stone, false, () -> Items.STATUE_GRANITE))
+        .withSound(BlockSounds.STONE).withHardness(1.5F)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NOT_IN_CREATIVE_MENU);
+    public static final Block<BlockLogicStatue> STATUE_MARBLE_LOWER = register("statue.marble.lower", "minecraft:block/statue_marble_lower", 1018, (BlockLogicSupplier<BlockLogicStatue>) b -> new BlockLogicStatue(b, Material.stone, true, () -> Items.STATUE_MARBLE))
+        .withSound(BlockSounds.STONE).withHardness(1.5F)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NOT_IN_CREATIVE_MENU);
+    public static final Block<BlockLogicStatue> STATUE_MARBLE_UPPER = register("statue.marble.upper", "minecraft:block/statue_marble_upper", 1019, (BlockLogicSupplier<BlockLogicStatue>) b -> new BlockLogicStatue(b, Material.stone, false, () -> Items.STATUE_MARBLE))
+        .withSound(BlockSounds.STONE).withHardness(1.5F)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NOT_IN_CREATIVE_MENU);
+    public static final Block<BlockLogicStatue> STATUE_PIGMAN_LOWER = register("statue.pigman.lower", "minecraft:block/statue_pigman_lower", 1020, (BlockLogicSupplier<BlockLogicStatue>) b -> new BlockLogicStatue(b, Material.stone, true, () -> Items.STATUE_PIGMAN))
+        .withSound(BlockSounds.STONE).withHardness(1.5F)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NOT_IN_CREATIVE_MENU);
+    public static final Block<BlockLogicStatue> STATUE_PIGMAN_UPPER = register("statue.pigman.upper", "minecraft:block/statue_pigman_upper", 1021, (BlockLogicSupplier<BlockLogicStatue>) b -> new BlockLogicStatue(b, Material.stone, false, () -> Items.STATUE_PIGMAN))
+        .withSound(BlockSounds.STONE).withHardness(1.5F)
+        .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.NOT_IN_CREATIVE_MENU);
+
 
     public static <T extends BlockLogic> Block<T> register(String key, String namespaceId, int id, BlockLogicSupplier<T> logicSupplier) {
         Block<T> container = new Block<>(id, key, namespaceId, logicSupplier);
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java
index 39c94be5b..ecbc1c78a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java
@@ -139,7 +139,7 @@ public class TileEntity implements ICarriable
         worldObj = world;
         this.validate();
         world.removeBlockTileEntity(x, y, z);
-        world.setBlockTileEntity(x, y, z, this);
+        world.setTileEntity(x, y, z, this);
         Block<?> b = world.getBlock(x, y, z);
         if (b != null && holder instanceof Mob) {
             b.onBlockPlacedByMob(world, x, y, z, side, (Mob) holder, xPlaced, yPlaced);
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
index f678818a5..cdcd2ebd8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityActivator.java
@@ -184,7 +184,7 @@ public class TileEntityActivator extends TileEntity implements Container {
     @Override
     public boolean stillValid(Player entityplayer)
     {
-        if(worldObj.getBlockEntity(x, y, z) != this)
+        if(worldObj == null || worldObj.getTileEntity(x, y, z) != this)
         {
             return false;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
index b9be6cd03..13e4abeb3 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
@@ -11,7 +11,7 @@ import net.minecraft.core.item.ItemStack;
 import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.tags.ListTag;
 import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.PacketBlockEntityData;
+import net.minecraft.core.net.packet.PacketTileEntityData;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 
@@ -203,7 +203,7 @@ public class TileEntityBasket extends TileEntity
 
     @Override
     public Packet getDescriptionPacket() {
-        return new PacketBlockEntityData(this);
+        return new PacketTileEntityData(this);
     }
 
     @Override
